
#ifndef _WAVEFORMATEX
	WAVEFORMATEX STRUCT
		wFormatTag DW
		nChannels DW
		nSamplesPerSec DD
		nAvgBytesPerSec DD
		nBlockAlign DW
		wBitsPerSample DW
		cbSize DW
	ENDS
#endif

#ifndef DRV_LOAD
	#define DRV_LOAD  0x0001
	#define DRV_ENABLE  0x0002
	#define DRV_OPEN  0x0003
	#define DRV_CLOSE  0x0004
	#define DRV_DISABLE  0x0005
	#define DRV_FREE  0x0006
	#define DRV_CONFIGURE  0x0007
	#define DRV_QUERYCONFIGURE  0x0008
	#define DRV_INSTALL  0x0009
	#define DRV_REMOVE  0x000A
	#define DRV_EXITSESSION  0x000B
	#define DRV_POWER  0x000F
	#define DRV_RESERVED  0x0800
	#define DRV_USER  0x4000
#ENDIF

#define DRV_MAPPER_PREFERRED_INPUT_GET  (DRV_USER+0)
#define DRV_MAPPER_PREFERRED_OUTPUT_GET  (DRV_USER+2)

#define DRVM_MAPPER  0x2000
#define DRVM_MAPPER_STATUS  0x2000

#define WIDM_MAPPER_STATUS  0x2000
#define WAVEIN_MAPPER_STATUS_DEVICE  0
#define WAVEIN_MAPPER_STATUS_MAPPED  1
#define WAVEIN_MAPPER_STATUS_FORMAT  2

#define WODM_MAPPER_STATUS  0x2000
#define WAVEOUT_MAPPER_STATUS_DEVICE  0
#define WAVEOUT_MAPPER_STATUS_MAPPED  1
#define WAVEOUT_MAPPER_STATUS_FORMAT  2

#define ACMERR_BASE  512
#define ACMERR_NOTPOSSIBLE  512
#define ACMERR_BUSY  513
#define ACMERR_UNPREPARED  514
#define ACMERR_CANCELED  515

#define MM_ACM_OPEN  0x3D4
#define MM_ACM_CLOSE  0x3D5
#define MM_ACM_DONE  0x3D6

#define ACM_METRIC_COUNT_DRIVERS  1
#define ACM_METRIC_COUNT_CODECS  2
#define ACM_METRIC_COUNT_CONVERTERS  3
#define ACM_METRIC_COUNT_FILTERS  4
#define ACM_METRIC_COUNT_DISABLED  5
#define ACM_METRIC_COUNT_HARDWARE  6
#define ACM_METRIC_COUNT_LOCAL_DRIVERS  20
#define ACM_METRIC_COUNT_LOCAL_CODECS  21
#define ACM_METRIC_COUNT_LOCAL_CONVERTERS  22
#define ACM_METRIC_COUNT_LOCAL_FILTERS  23
#define ACM_METRIC_COUNT_LOCAL_DISABLED  24
#define ACM_METRIC_HARDWARE_WAVE_INPUT  30
#define ACM_METRIC_HARDWARE_WAVE_OUTPUT  31
#define ACM_METRIC_MAX_SIZE_FORMAT  50
#define ACM_METRIC_MAX_SIZE_FILTER  51
#define ACM_METRIC_DRIVER_SUPPORT  100
#define ACM_METRIC_DRIVER_PRIORITY  101

#define ACM_DRIVERENUMF_NOLOCAL  0x40000000
#define ACM_DRIVERENUMF_DISABLED  0x80000000

#define ACM_DRIVERADDF_FUNCTION  0x00000003
#define ACM_DRIVERADDF_NOTIFYHWND  0x00000004
#define ACM_DRIVERADDF_TYPEMASK  0x00000007
#define ACM_DRIVERADDF_LOCAL  0x00000000
#define ACM_DRIVERADDF_GLOBAL  0x00000008

#define ACMDM_USER  (DRV_USER+0x0000)
#define ACMDM_RESERVED_LOW  (DRV_USER+0x2000)
#define ACMDM_RESERVED_HIGH  (DRV_USER+0x2FFF)

#define ACMDM_BASE  ACMDM_RESERVED_LOW

#define ACMDM_DRIVER_ABOUT  (ACMDM_BASE+11)

#define ACM_DRIVERPRIORITYF_ENABLE  0x00000001
#define ACM_DRIVERPRIORITYF_DISABLE  0x00000002
#define ACM_DRIVERPRIORITYF_ABLEMASK  0x00000003
#define ACM_DRIVERPRIORITYF_BEGIN  0x00010000
#define ACM_DRIVERPRIORITYF_END  0x00020000
#define ACM_DRIVERPRIORITYF_DEFERMASK  0x00030000

#define ACMDRIVERDETAILS_SHORTNAME_CHARS  32
#define ACMDRIVERDETAILS_LONGNAME_CHARS  128
#define ACMDRIVERDETAILS_COPYRIGHT_CHARS  80
#define ACMDRIVERDETAILS_LICENSING_CHARS  128
#define ACMDRIVERDETAILS_FEATURES_CHARS  512


#define ACMDRIVERDETAILS_SUPPORTF_CODEC  0x00000001
#define ACMDRIVERDETAILS_SUPPORTF_CONVERTER  0x00000002
#define ACMDRIVERDETAILS_SUPPORTF_FILTER  0x00000004
#define ACMDRIVERDETAILS_SUPPORTF_HARDWARE  0x00000008
#define ACMDRIVERDETAILS_SUPPORTF_ASYNC  0x00000010
#define ACMDRIVERDETAILS_SUPPORTF_LOCAL  0x40000000
#define ACMDRIVERDETAILS_SUPPORTF_DISABLED  0x80000000

#define ACMFORMATTAGDETAILS_FORMATTAG_CHARS  48

#define ACM_FORMATTAGDETAILSF_INDEX  0x00000000
#define ACM_FORMATTAGDETAILSF_FORMATTAG  0x00000001
#define ACM_FORMATTAGDETAILSF_LARGESTSIZE  0x00000002
#define ACM_FORMATTAGDETAILSF_QUERYMASK  0x0000000F

/*
#define MAKEFOURCC(ch0,ch1,ch2,ch3)  ((DWORD)(BYTE)(ch0)|((DWORD)(BYTE)(ch1)<<8)|((DWORD)(BYTE)(ch2)<<16)|((DWORD)(BYTE)(ch3)<<24))
mmioFOURCC = MAKEFOURCC
#define ACMDRIVERDETAILS_FCCTYPE_AUDIOCODEC mmioFOURCC('a','u','d','c')
#define ACMDRIVERDETAILS_FCCCOMP_UNDEFINED mmioFOURCC('\0','\0','\0','\0')
*/

#define ACMDRIVERDETAILS_FCCTYPE_AUDIOCODEC "audc"
#define ACMDRIVERDETAILS_FCCCOMP_UNDEFINED 0

#define ACMFORMATDETAILS_FORMAT_CHARS  128

#define ACM_FORMATDETAILSF_INDEX  0x00000000
#define ACM_FORMATDETAILSF_FORMAT  0x00000001
#define ACM_FORMATDETAILSF_QUERYMASK  0x0000000F

#define ACM_FORMATENUMF_WFORMATTAG  0x00010000
#define ACM_FORMATENUMF_NCHANNELS  0x00020000
#define ACM_FORMATENUMF_NSAMPLESPERSEC  0x00040000
#define ACM_FORMATENUMF_WBITSPERSAMPLE  0x00080000
#define ACM_FORMATENUMF_CONVERT  0x00100000
#define ACM_FORMATENUMF_SUGGEST  0x00200000
#define ACM_FORMATENUMF_HARDWARE  0x00400000
#define ACM_FORMATENUMF_INPUT  0x00800000
#define ACM_FORMATENUMF_OUTPUT  0x01000000

#define ACM_FORMATSUGGESTF_WFORMATTAG  0x00010000
#define ACM_FORMATSUGGESTF_NCHANNELS  0x00020000
#define ACM_FORMATSUGGESTF_NSAMPLESPERSEC  0x00040000
#define ACM_FORMATSUGGESTF_WBITSPERSAMPLE  0x00080000
#define ACM_FORMATSUGGESTF_TYPEMASK  0x00FF0000

#define ACMHELPMSGSTRINGA  "acmchoose_help"
#define ACMHELPMSGSTRINGW  L"acmchoose_help"
#define ACMHELPMSGCONTEXTMENUA  "acmchoose_contextmenu"
#define ACMHELPMSGCONTEXTMENUW  L"acmchoose_contextmenu"
#define ACMHELPMSGCONTEXTHELPA  "acmchoose_contexthelp"
#define ACMHELPMSGCONTEXTHELPW  L"acmchoose_contexthelp"

#define MM_ACM_FORMATCHOOSE  0x8000

#define FORMATCHOOSE_MESSAGE  0
#define FORMATCHOOSE_FORMATTAG_VERIFY  0
#define FORMATCHOOSE_FORMAT_VERIFY  1
#define FORMATCHOOSE_CUSTOM_VERIFY  2

#define ACMFORMATCHOOSE_STYLEF_SHOWHELP  0x00000004
#define ACMFORMATCHOOSE_STYLEF_ENABLEHOOK  0x00000008
#define ACMFORMATCHOOSE_STYLEF_ENABLETEMPLATE  0x00000010
#define ACMFORMATCHOOSE_STYLEF_ENABLETEMPLATEHANDLE  0x00000020
#define ACMFORMATCHOOSE_STYLEF_INITTOWFXSTRUCT  0x00000040
#define ACMFORMATCHOOSE_STYLEF_CONTEXTHELP  0x00000080

#define ACMFILTERTAGDETAILS_FILTERTAG_CHARS  48

#define ACM_FILTERTAGDETAILSF_INDEX  0x00000000
#define ACM_FILTERTAGDETAILSF_FILTERTAG  0x00000001
#define ACM_FILTERTAGDETAILSF_LARGESTSIZE  0x00000002
#define ACM_FILTERTAGDETAILSF_QUERYMASK  0x0000000F

#define ACMFILTERDETAILS_FILTER_CHARS  128

#define ACM_FILTERDETAILSF_INDEX  0x00000000
#define ACM_FILTERDETAILSF_FILTER  0x00000001
#define ACM_FILTERDETAILSF_QUERYMASK  0x0000000F

#define ACM_FILTERENUMF_DWFILTERTAG  0x00010000

#define FILTERCHOOSE_MESSAGE  0
#define FILTERCHOOSE_FILTERTAG_VERIFY  0
#define FILTERCHOOSE_FILTER_VERIFY  1
#define FILTERCHOOSE_CUSTOM_VERIFY  2

#define ACMFILTERCHOOSE_STYLEF_SHOWHELP  0x00000004
#define ACMFILTERCHOOSE_STYLEF_ENABLEHOOK  0x00000008
#define ACMFILTERCHOOSE_STYLEF_ENABLETEMPLATE  0x00000010
#define ACMFILTERCHOOSE_STYLEF_ENABLETEMPLATEHANDLE  0x00000020
#define ACMFILTERCHOOSE_STYLEF_INITTOFILTERSTRUCT  0x00000040
#define ACMFILTERCHOOSE_STYLEF_CONTEXTHELP  0x00000080

#define ACMSTREAMHEADER_STATUSF_DONE  0x00010000
#define ACMSTREAMHEADER_STATUSF_PREPARED  0x00020000
#define ACMSTREAMHEADER_STATUSF_INQUEUE  0x00100000

#define ACM_STREAMOPENF_QUERY  0x00000001
#define ACM_STREAMOPENF_ASYNC  0x00000002
#define ACM_STREAMOPENF_NONREALTIME  0x00000004

#define ACM_STREAMSIZEF_SOURCE  0x00000000
#define ACM_STREAMSIZEF_DESTINATION  0x00000001
#define ACM_STREAMSIZEF_QUERYMASK  0x0000000F

#define ACM_STREAMCONVERTF_BLOCKALIGN  0x00000004
#define ACM_STREAMCONVERTF_START  0x00000010
#define ACM_STREAMCONVERTF_END  0x00000020

ACMDRIVERDETAILSA struct
  cbStruct DD
  fccType DD
  fccComp DD
  wMid DW
  wPid DW
  vdwACM DD 
  vdwDriver DD 
  fdwSupport DD
  cFormatTags DD
  cFilterTags DD
  hicon DD
  szShortName DB ACMDRIVERDETAILS_SHORTNAME_CHARS DUP ?
  szLongName DB ACMDRIVERDETAILS_LONGNAME_CHARS DUP ?
  szCopyright DB ACMDRIVERDETAILS_COPYRIGHT_CHARS DUP ?
  szLicensing DB ACMDRIVERDETAILS_LICENSING_CHARS DUP ?
  szFeatures DB ACMDRIVERDETAILS_FEATURES_CHARS DUP ?
ENDS

ACMDRIVERDETAILSW struct
  cbStruct DD
  fccType DD
  fccComp DD
  wMid DW
  wPid DW
  vdwACM DD 
  vdwDriver DD 
  fdwSupport DD
  cFormatTags DD
  cFilterTags DD
  hicon DD
  szShortName DW ACMDRIVERDETAILS_SHORTNAME_CHARS DUP ? 
  szLongName DW ACMDRIVERDETAILS_LONGNAME_CHARS DUP ? 
  szCopyright DW ACMDRIVERDETAILS_COPYRIGHT_CHARS DUP ?
  szLicensing DW ACMDRIVERDETAILS_LICENSING_CHARS DUP ?
  szFeatures DW ACMDRIVERDETAILS_FEATURES_CHARS DUP ?
ENDS

ACMFORMATTAGDETAILSA STRUCT
	cbStruct DD
	dwFormatTagIndex DD
	dwFormatTag DD
	cbFormatSize DD
	fdwSupport DD
	cStandardFormats DD
	szFormatTag DB ACMFORMATTAGDETAILS_FORMATTAG_CHARS DUP ?
ENDS

ACMFORMATTAGDETAILSW STRUCT
	cbStruct DD
	dwFormatTagIndex DD
	dwFormatTag DD
	cbFormatSize DD
	fdwSupport DD
	cStandardFormats DD
	szFormatTag DW ACMFORMATTAGDETAILS_FORMATTAG_CHARS DUP ?
ENDS

ACMFORMATDETAILSA STRUCT
	cbStruct DD
	dwFormatIndex DD
	dwFormatTag DD
	fdwSupport DD
	pwfx DD
	cbwfx DD
	szFormat DB ACMFORMATDETAILS_FORMAT_CHARS DUP ?
ENDS

ACMFORMATDETAILSW STRUCT
	cbStruct DD
	dwFormatIndex DD
	dwFormatTag DD
	fdwSupport DD
	pwfx DD
	cbwfx DD
	szFormat DW ACMFORMATDETAILS_FORMAT_CHARS DUP ?
ENDS

ACMFORMATCHOOSEA STRUCT
	cbStruct DD
	fdwStyle DD
	hwndOwner DD
	pwfx DD
	cbwfx DD
	pszTitle DD
	szFormatTag DB ACMFORMATTAGDETAILS_FORMATTAG_CHARS DUP?
	szFormat DB ACMFORMATDETAILS_FORMAT_CHARS DUP ?
	pszName DD
	cchName DD
	fdwEnum DD
	pwfxEnum DD
	hInstance DD
	pszTemplateName DD
	lCustData DD
	pfnHook DD
ENDS

ACMFORMATCHOOSEW STRUCT
	cbStruct DD
	fdwStyle DD
	hwndOwner DD
	pwfx DD
	cbwfx DD
	pszTitle DD
	szFormatTag DW ACMFORMATTAGDETAILS_FORMATTAG_CHARS DUP?
	szFormat DW ACMFORMATDETAILS_FORMAT_CHARS DUP ?
	pszName DD
	cchName DD
	fdwEnum DD
	pwfxEnum DD
	hInstance DD
	pszTemplateName DD
	lCustData DD
	pfnHook DD
ENDS

ACMFILTERTAGDETAILSA STRUCT
	cbStruct DD
	dwFilterTagIndex DD
	dwFilterTag DD
	cbFilterSize DD
	fdwSupport DD
 	cStandardFilters DD
	szFilterTag DB ACMFILTERTAGDETAILS_FILTERTAG_CHARS DUP ?
ENDS

ACMFILTERTAGDETAILSW STRUCT
	cbStruct DD
	dwFilterTagIndex DD
	dwFilterTag DD
	cbFilterSize DD
	fdwSupport DD
 	cStandardFilters DD
	szFilterTag DW ACMFILTERTAGDETAILS_FILTERTAG_CHARS DUP ?
ENDS

ACMFILTERDETAILSA STRUCT
	cbStruct DD
	dwFilterIndex DD
	dwFilterTag DD
	fdwSupport DD
	pwfltr DD
	cbwfltr DD
	szFilter DB ACMFILTERDETAILS_FILTER_CHARS DUP ?
ENDS

ACMFILTERDETAILSW STRUCT
	cbStruct DD
	dwFilterIndex DD
	dwFilterTag DD
	fdwSupport DD
	pwfltr DD
	cbwfltr DD
	szFilter DW ACMFILTERDETAILS_FILTER_CHARS DUP ?
ENDS

ACMFILTERCHOOSEA STRUCT
	cbStruct DD
 	fdwStyle DD
	hwndOwner DD
	pwfltr DD
	cbwfltr DD
	pszTitle DD
	szFilterTag DB ACMFILTERTAGDETAILS_FILTERTAG_CHARS DUP ?
	szFilter DB ACMFILTERDETAILS_FILTER_CHARS DUP ?
	pszName DD
	cchName DD
	fdwEnum DD
	pwfltrEnum DD
	hInstance DD
	pszTemplateName DD
	lCustData DD
	pfnHook DD
ENDS

ACMFILTERCHOOSEW STRUCT
	cbStruct DD
 	fdwStyle DD
	hwndOwner DD
	pwfltr DD
	cbwfltr DD
	pszTitle DD
	szFilterTag DW ACMFILTERTAGDETAILS_FILTERTAG_CHARS DUP ?
	szFilter DW ACMFILTERDETAILS_FILTER_CHARS DUP ?
	pszName DD
	cchName DD
	fdwEnum DD
	pwfltrEnum DD
	hInstance DD
	pszTemplateName DD
	lCustData DD
	pfnHook DD
ENDS

ACMSTREAMHEADER STRUCT
    DWORD cbStruct DD
    DWORD fdwStatus DD
    DWORD_PTR dwUser DD
    LPBYTE pbSrc DD
    DWORD cbSrcLength DD
    DWORD cbSrcLengthUsed DD
    DWORD_PTR dwSrcUser DD
    LPBYTE pbDst DD
    DWORD cbDstLength DD
    DWORD cbDstLengthUsed DD
    DWORD_PTR dwDstUser DD
    DWORD dwReservedDriver DD 10 DUP ?
ENDS

#if STRINGS UNICODE
	#define ACMDRIVERDETAILS ACMDRIVERDETAILSW
	#define ACMFORMATTAGDETAILS ACMFORMATTAGDETAILSW
	#define ACMFORMATTAGENUMCB ACMFORMATTAGENUMCBW
	#define ACMFORMATDETAILS ACMFORMATDETAILSW
	#define ACMHELPMSGSTRING ACMHELPMSGSTRINGW
	#define ACMHELPMSGCONTEXTMENU ACMHELPMSGCONTEXTMENUW
	#define ACMHELPMSGCONTEXTHELP ACMHELPMSGCONTEXTHELPW
	#define ACMFORMATCHOOSE ACMFORMATCHOOSEW
	#define ACMFILTERTAGDETAILS ACMFILTERTAGDETAILSW
	#define ACMFILTERDETAILS ACMFILTERDETAILSW
	#define ACMFILTERCHOOSE ACMFILTERCHOOSEW
	#define acmDriverAdd acmDriverAddW
	#define acmDriverDetails  acmDriverDetailsW
	#define acmFormatTagDetails acmFormatTagDetailsW
	#define acmFormatTagEnum acmFormatTagEnumW
	#define acmFormatDetails acmFormatDetailsW
	#define acmFormatEnum acmFormatEnumW
	#define acmFormatChoose acmFormatChooseW
	#define acmFilterTagDetails acmFilterTagDetailsW
	#define acmFilterTagEnum acmFilterTagEnumW
	#define acmFilterDetails acmFilterDetailsW
	#define acmFilterEnum acmFilterEnumW
	#define acmFilterChoose acmFilterChooseW
#else /* UNICODE */
	#define ACMDRIVERDETAILS ACMDRIVERDETAILSA
	#define ACMFORMATTAGDETAILS ACMFORMATTAGDETAILSA
	#define ACMFORMATTAGENUMCB ACMFORMATTAGENUMCBA
	#define ACMFORMATDETAILS ACMFORMATDETAILSA
	#define ACMHELPMSGSTRING ACMHELPMSGSTRINGA
	#define ACMHELPMSGCONTEXTMENU ACMHELPMSGCONTEXTMENUA
	#define ACMHELPMSGCONTEXTHELP ACMHELPMSGCONTEXTHELPA
	#define ACMFORMATCHOOSE ACMFORMATCHOOSEA
	#define ACMFILTERTAGDETAILS ACMFILTERTAGDETAILSA
	#define ACMFILTERDETAILS ACMFILTERDETAILSA
	#define ACMFILTERCHOOSE ACMFILTERCHOOSEA
	#define acmDriverAdd acmDriverAddA
	#define acmDriverDetails  acmDriverDetailsA
	#define acmFormatTagDetails acmFormatTagDetailsA
	#define acmFormatTagEnum acmFormatTagEnumA
	#define acmFormatDetails acmFormatDetailsA
	#define acmFormatEnum acmFormatEnumA
	#define acmFormatChoose acmFormatChooseA
	#define acmFilterTagDetails acmFilterTagDetailsA
	#define acmFilterTagEnum acmFilterTagEnumA
	#define acmFilterDetails acmFilterDetailsA
	#define acmFilterEnum acmFilterEnumA
	#define acmFilterChoose acmFilterChooseA
#endif /* UNICODE */
